<?php

$sRootPath = dirname(__FILE__);

while((strlen($sRootPath) > 2) && !is_dir($sRootPath . '/idealcheckout'))
{
	 $sRootPath = dirname($sRootPath);
}

if(!is_dir($sRootPath . '/idealcheckout'))
{
	 die('Cannot find /idealcheckout/ folder.<br>File: ' . __FILE__ . '<br>Line: ' . __LINE__);
}

require_once($sRootPath . '/idealcheckout/includes/library.php');



class idealcheckoutideal
{
	var $code, $title;
	var $osDB;

	// class constructor
	function idealcheckoutideal() 
	{
		$this->code = 'idealcheckoutideal';
		$this->title = 'iDEAL';
		$this->osDB = & $GLOBALS['osDB'];

		$this->form_action_url = '';
	}

	// class methods
	function javascript_validation() 
	{
		return false;
	}

	function process_button() 
	{
		global $t;

		// Find system information
		$sTransactionId = $_SESSION['pay_txn_id'];
		$sInvoiceId = $_SESSION['invoice_no'];
		$sUserId = $_SESSION['UserId'];
		$sMembershipId = $_POST['membership'];
		$sPaymentMethod = $_POST['payment'];

		// iDEAL Message
		$sIdealCheckoutMessage = '';

		// Lookup record
		$sql = "SELECT * FROM `" . TRANSACTIONS_TABLE . "` WHERE (`id` = '" . idealcheckout_escapeSql($sTransactionId) . "') AND (`invoice_no` = '" . idealcheckout_escapeSql($sInvoiceId) . "') AND (`user_id` = '" . idealcheckout_escapeSql($sUserId) . "') AND (`payment_status` = 'Started') LIMIT 1";

		if($aTransaction = idealcheckout_database_getRecord($sql))
		{
			if($aTransaction['amount_paid'] >= 1.00)
			{
				$aDatabaseSettings = idealcheckout_getDatabaseSettings();
				

				$sStoreCode = idealcheckout_getStoreCode();
				$sGatewayCode = 'ideal';
				$sLanguageCode = ''; // nl, de, en
				$sCountryCode = '';
				$sCurrencyCode = 'EUR';

				$sOrderId = $aTransaction['id'];
				$sOrderCode = idealcheckout_getRandomCode(32);
				$sTransactionId = idealcheckout_getRandomCode(32);
				$sTransactionCode = idealcheckout_getRandomCode(32);
				$fTransactionAmount = $aTransaction['amount_paid'];
				$sTransactionDescription = idealcheckout_getTranslation($sLanguageCode, 'idealcheckout', 'Account update #{0}', array($sOrderId));
				$sTransactionPaymentUrl = idealcheckout_getRootUrl() . 'idealcheckout.php?order_id=' . $sOrderId . '&order_code=' . $sOrderCode;
				$sTransactionSuccessUrl = $sTransactionPaymentUrl;
				$sTransactionPendingUrl = $sTransactionPaymentUrl;
				$sTransactionFailureUrl = $sTransactionPaymentUrl;
				$aOrderParams = array('id' => $aTransaction['id'], 'invoice_no' => $aTransaction['invoice_no'], 'user_id' => $sUserId);


				// Insert into #_transactions
				$sql = "INSERT INTO `" . $aDatabaseSettings['table'] . "` SET 
`id` = NULL, 
`order_id` = '" . idealcheckout_escapeSql($sOrderId) . "', 
`order_code` = '" . idealcheckout_escapeSql($sOrderCode) . "', 
`order_params` = '" . idealcheckout_escapeSql(idealcheckout_serialize($aOrderParams)) . "', 
`store_code` = " . (empty($sStoreCode) ? "NULL" : "'" . idealcheckout_escapeSql($sStoreCode) . "'") . ", 
`gateway_code` = '" . idealcheckout_escapeSql($sGatewayCode) . "', 
`language_code` = " . (empty($sLanguageCode) ? "NULL" : "'" . idealcheckout_escapeSql($sLanguageCode) . "'") . ", 
`country_code` = " . (empty($sCountryCode) ? "NULL" : "'" . idealcheckout_escapeSql($sCountryCode) . "'") . ", 
`currency_code` = '" . idealcheckout_escapeSql($sCurrencyCode) . "', 
`transaction_id` = '" . idealcheckout_escapeSql($sTransactionId) . "', 
`transaction_code` = '" . idealcheckout_escapeSql($sTransactionCode) . "', 
`transaction_params` = NULL, 
`transaction_date` = '" . idealcheckout_escapeSql(time()) . "', 
`transaction_amount` = '" . idealcheckout_escapeSql($fTransactionAmount) . "', 
`transaction_description` = '" . idealcheckout_escapeSql($sTransactionDescription) . "', 
`transaction_status` = NULL, 
`transaction_url` = NULL, 
`transaction_payment_url` = '" . idealcheckout_escapeSql($sTransactionPaymentUrl) . "', 
`transaction_success_url` = '" . idealcheckout_escapeSql($sTransactionSuccessUrl) . "', 
`transaction_pending_url` = '" . idealcheckout_escapeSql($sTransactionPendingUrl) . "', 
`transaction_failure_url` = '" . idealcheckout_escapeSql($sTransactionFailureUrl) . "', 
`transaction_log` = NULL;";

				idealcheckout_database_query($sql);

				// Redirect to iDEAL setup
				header('Location: ' . idealcheckout_getRootUrl() . 'idealcheckout/setup.php?order_id=' . $sOrderId . '&order_code=' . $sOrderCode);
				exit;
			}
			else
			{
				$sIdealCheckoutMessage = 'Payment should be at least &euro; 1,50.';
			}
		}
		else
		{
			$sIdealCheckoutMessage = 'Cannot find transaction. Please try again.';
		}

		$t->assign('idealcheckout_message', $sIdealCheckoutMessage);
		$t->assign('rendered_page', $t->fetch('idealcheckout_message.tpl'));
	}

	function before_process() 
	{
		return false;
	}

	function after_process() 
	{
		return false;
	}

	function output_error() 
	{
		return false;
	}

	function check() 
	{
		return true;
	}

	function install() 
	{
	}

	function update($configuration)
	{
	}

	function remove() 
	{
	}

	function keys()
	{
	}
}

?>